
%%%%%%%%%%% Initial Assumptions %%%%%%%%%%%%%%%%%%%%%%%%%
clear all 
close all
clc  
alpha=1;
gamma=1/alpha;

n=100;

A = ones(1, n);


generate_newproblem=0;
if (generate_newproblem)
eps=1.0e-15;
max_itr=500;
y=[0:1/(n-1):1]';  
u = sin(2*pi*y)+0.8*randn(n, 1) ;            %  Assign value to u in ||x-u||

x=u;
b = A * x;           %% Compute b as the result of A*x
 
else
eps=1.0e-12;
max_itr=8000;    
load('problem_data.mat','b','u','x_star_new','x_star_DY')
end
 


z_old=zeros(n,1);
A_pseudoinv = A'*inv(A*A');          %% Compute pseudo inverse of A for function h=d_3

num_iter=1;
res=[];
err=[];
while num_iter<max_itr
    vec_z_new = zeros(n, 1); 
    vec_v = zeros(n, 1); 
    vec_p= zeros(n, 1); 

    vec_w= z_old+A_pseudoinv*(b-A*z_old);             %% w^k
 
    vec_p=2*vec_w-z_old-gamma.*alpha.*(vec_w-u);          %% p^{k+1}
    % for i = 1:n
    %         prox_vec_p = min(max(vec_p(i), -1.0), 1.0);                 %% Prox_d_2(p^{k+1})
    %         vec_v=prox_vec_p+ gamma.*alpha.*(vec_w(i)-u(i));            %% v^{k+1}
	% 	    prox_vec_v = (1./(alpha.*gamma + 1.0)).*vec_v + (alpha.*gamma./(alpha.*gamma + 1.0)).*u(i);       
    %         z_new(i) = z_old(i) + prox_vec_v - vec_w(i);             %% z^{k+1}
    % end
    
    prox_vec_p = min(max(vec_p, -1.0), 1.0);
    vec_v=prox_vec_p+ gamma.*alpha.*(vec_w-u); 
    prox_vec_v = (1/(alpha*gamma + 1.0))*vec_v + (alpha*gamma/(alpha*gamma + 1.0))*u;
    z_new = z_old + prox_vec_v - vec_w;

    residue = norm(z_new - z_old);
    res=[res; residue];

    if (generate_newproblem)
    else
        error=norm(x_star_new-vec_w);
        err=[err; error]; 
    end
    if residue < eps
            disp('The residue at current iteration is smaller than the assumed tolerance eps')
            break;
    end

        z_old = z_new;
        num_iter = num_iter + 1;
    end
% vec_z_star(:) = z_new;
x_star_new=vec_w;
res1=res;
err_new=err;

% Davis-Yin
num_iter=1;
res=[];
err=[];
vec_w = zeros(n, 1); 
vec_p = zeros(n, 1); 
vec_z_new = zeros(n, 1); 

z_old=zeros(n,1);

while num_iter<max_itr 
    
 

    vec_w= z_old + A_pseudoinv*(b-A*z_old);             %% w^k
    vec_p=2*vec_w-z_old-gamma.*alpha.*(vec_w-u);                  %% z^{k+1/2}   
    z_half = min(max(vec_p, -1.0), 1.0);
    vec_z_new=z_old+z_half-vec_w;
    
       residue = norm(vec_z_new - z_old);
       res=[res; residue];

       if (generate_newproblem)
       else
          error=norm(x_star_DY-vec_w);
          err=[err; error]; 
       end

        if residue < eps
            disp('The residue at current iteration is smaller than the assumed tolerance eps')
            break;
        end

        z_old = vec_z_new;
        num_iter = num_iter + 1;
    end
% vec_z_star(:) = vec_z_new;
x_star_DY=vec_w;
err_DY=err;

if (generate_newproblem)
   save('problem_data.mat','b','u','x_star_new','x_star_DY')
else
end    


handle.cost=figure;
set(0,'CurrentFigure',handle.cost)
set(handle.cost, 'Position', [0 0 1200 800])
set(0,'DefaultTextFontSize',30,'DefaultAxesFontSize', 30)
set(gca,'FontSize',30)

if (generate_newproblem)

semilogy(res1,'o','MarkerSize',20,'LineWidth',2); 

xlabel('Iteration number')
ylabel('$\|z^k-z^{k+1}\|$','Interpreter','latex') 

hold all
semilogy(res,'+', 'MarkerSize', 20,'LineWidth',2);

legend('Proposed splitting ','Davis-Yin splitting')


else

semilogy(err_new,'o','MarkerSize',20,'LineWidth',2); 

xlabel('Iteration number')
ylabel('$\|x^{k+\frac{1}{2}}-x^*\|$','Interpreter','latex') 

hold all
semilogy(err_DY,'+', 'MarkerSize', 20,'LineWidth',2);

legend('Proposed splitting ','Davis-Yin splitting')
 
end